Subject: Re: [PATCH iproute2] tc: m_tunnel_key: fix geneve opt output

From: Simon Horman <[email-masked]>
Date: Fri, 19 Jun 2020 08:56:43 +0200

On Fri, Jun 19, 2020 at 10:25:24AM +0800, Hangbin Liu wrote:
> On Thu, Jun 18, 2020 at 12:51:08PM +0200, Simon Horman wrote:
> > On Thu, Jun 18, 2020 at 06:44:20PM +0800, Hangbin Liu wrote:
> > > Commit f72c3ad00f3b changed the geneve option output from "geneve_opt"
> > > to "geneve_opts", which may break the program compatibility. Reset
> > > it back to geneve_opt.
> > > 
> > > Fixes: f72c3ad00f3b ("tc: m_tunnel_key: add options support for vxlan")
> > > Signed-off-by: Hangbin Liu <[email-masked]>
> > 
> > Thanks Hangbin.
> > 
> > I agree that the patch in question did change the name of the option
> > as you describe, perhaps inadvertently. But I wonder if perhaps this fix
> > is too simple as the patch mentioned also:
> > 
> > 1. Documents the option as geneve_opts
> > 2. Adds vxlan_opts
> > 
> > So this patch invalidates the documentation and creates asymmetry between
> > the VXLAN and Geneve variants of this feature.
> 
> Not sure if I understand you comment correctly. This patch only fix the cmd
> output(revert to previous output format), The cmd option is not changed. e.g.
> 
> # tc actions add action tunnel_key set src_ip 1.1.1.1 dst_ip 2.2.2.2 id 42 \
>      dst_port 6081 geneve_opts 0102:80:00880022 index 1
> # tc actions get action tunnel_key index 1
> total acts 0
> 
>         action order 1: tunnel_key  set
>         src_ip 1.1.1.1
>         dst_ip 2.2.2.2
>         key_id 42
>         dst_port 6081
>         geneve_opt 0102:80:00880022
>         csum pipe
>          index 1 ref 1 bind 0
> 
> But this do make a asymmetry for vxlan and geneve output. I prefer
> to let them consistent personally. Also it looks more reasonable
> to output "geneve_opts" when we have parameter geneve_opts.
> 
> So I'm not going to fix it in iproute, but do as Davide mentioned, make
> tdc test case accept both 'geneve_opts' and 'geneve_opt'.

Thanks. I agree this seems to be the best way forward.